package com.ar.artracestudio.adapter;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.ar.artracestudio.R;
import com.ar.artracestudio.activity.CameraActivity;
import com.ar.artracestudio.room.AppDatabase;
import com.ar.artracestudio.room.ImageEntry;
import com.bumptech.glide.Glide;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;

import java.util.List;
import java.util.concurrent.Executors;

public class FavoriteAdapter extends RecyclerView.Adapter<FavoriteAdapter.ViewHolder> {

    private List<ImageEntry> imageEntries;  // 收藏的图片列表
    private final Context context;  // 上下文对象

    // 构造方法，传入上下文和图片列表
    public FavoriteAdapter(Context context, List<ImageEntry> imageEntries) {
        this.context = context;
        this.imageEntries = imageEntries;
    }

    // 更新适配器的数据
    public void updateData(List<ImageEntry> newFavoriteImages) {
        this.imageEntries = newFavoriteImages;
        notifyDataSetChanged();  // 通知 RecyclerView 数据已更新
    }

    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        // 膨胀 item 视图
        View view = LayoutInflater.from(context).inflate(R.layout.item_import, parent, false);
        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        // 获取当前 position 对应的 FavoriteImage 对象
        ImageEntry imageEntry = imageEntries.get(position);
        holder.bind(imageEntry);  // 绑定数据到 ViewHolder
    }

    @Override
    public int getItemCount() {
        // 返回列表中项的数量
        return imageEntries.size();
    }

    // ViewHolder 类，包含 RecyclerView 的每个 item 的视图
    class ViewHolder extends RecyclerView.ViewHolder {
        ImageView imageView;  // 显示图片的 ImageView
        ImageView favoriteButton;  // 显示收藏状态的按钮

        // 构造方法，初始化视图组件
        ViewHolder(View itemView) {
            super(itemView);
            imageView = itemView.findViewById(R.id.image_view);
            favoriteButton = itemView.findViewById(R.id.btn_favorite);
        }

        // 绑定数据到 ViewHolder 中的视图组件
        void bind(ImageEntry favoriteImage) {
            // 使用 Glide 加载图片，路径为 assets 中的图片
            String favoritePath = favoriteImage.getImagePath();

            Glide.with(context)
                    .load(favoritePath.startsWith("/data/user/")? favoritePath : "file:///android_asset/" + favoritePath)  // 加载 assets 中的图片
                    .transform(new RoundedCorners(20))
                    .into(imageView);

            imageView.setOnClickListener(v -> {

                Intent intent = new Intent(context, CameraActivity.class);
                intent.putExtra("imagePath", favoritePath);
                context.startActivity(intent);

            });

            // 动态观察 'isFavorite' 状态，并更新按钮的图标
            favoriteButton.setImageResource(favoriteImage.isFavoriteStatus() ? R.drawable.like : R.drawable.unlike);

            // 设置收藏按钮的点击事件，切换收藏状态
            favoriteButton.setOnClickListener(v -> {
                boolean newStatus = !favoriteImage.isFavoriteStatus();  // 取反收藏状态
                favoriteImage.setFavoriteStatus(newStatus);  // 更新状态

                // 在后台线程中更新数据库
                Executors.newSingleThreadExecutor().execute(() -> {
                    AppDatabase.getInstance(context)
                            .imageEntryDao()
                            .update(favoriteImage);  // 更新数据库中的收藏状态
                });

                // 更新当前项的收藏按钮图标
                notifyItemChanged(getAdapterPosition());
            });
        }
    }
}
